#!BPY
""" Registration info for Blender menus
Name: 'ph_Extruder'
Blender: 231
Group: 'Mesh'
Tooltip: 'Extrude by group or by faces with selected faces.'
"""

#### !<>

########################################################
#													   #
#				 ph_Extruder.py						   #
#													   #
#		  Cree par coolphil@worldonline.fr			   #
#				  le 28/04/2004						   #
#													   #
#		  Tient compte des 'materialIndex',			   #
#				  desVertexColors.					   #
#					et des UVs.						   #
#													   #
# http://hp.home.chez.tiscali.fr/re_illusion/index.htm #
#													   #
#													   #
#		 Derniere mise a jour le 01/08/2004			   #
#													   #
########################################################

import Blender
from Blender import Scene, Object, NMesh, Window
from Blender.Draw import *
from Blender.BGL import *

Undo = {}
level = 0
levelMax = 0
GrFV = []
modemesh = 0

tolerance = 0.0005
ChckHl = 0

checkExtrusion = 0
LastSelObj = []
checkbyFce = 0
checkCol = 0

togGrpFce = Create(0)
togGrpFceTxt = "By group."
capshole = Create(0)

interact = Create(0)

slOffset = Create(0.00)
slOffsetMax = Create(1)
slScale = Create(100.00)
slScaleMax = Create(200)

W_up = Create(0)
W_down = Create(1)
W_left = Create(1)
W_right = Create(0)

EVENT_EXIT = 1
EVENT_GRPFCE = 2
EVENT_OFF = 3
EVENT_SCALE = 4
EVENT_OFFMAX = 5
EVENT_EXTR = 6
EVENT_UNDO = 7
EVENT_REDO = 8
EVENT_FREE = 9
EVENT_WPOS_U = 10
EVENT_WPOS_D = 11
EVENT_WPOS_L = 12
EVENT_WPOS_R = 13


BL_VERSION = Blender.Get('version')
if (BL_VERSION<=223):
	import Blender210

################
def editbegin():
################
	global edit_mode, modemesh

	try:
		edit_mode = Window.EditMode()
		if edit_mode: Window.EditMode(0); modemesh = 1
	except:
		print "=============================="
		print "'EditMode()' INCOMPATIBILITY !"
	return 0

##############
def editend():
##############
	global modemesh

	try:
		if edit_mode: Window.EditMode(1)
	except:
		print "=============================="
		print "'EditMode()' INCOMPATIBILITY !"

	modemesh = 0

	return 0

###########################
def GlobalPosition(P, obj):
###########################
	#
	# Prend les coordonnees locale d'un point (Vertice from Mesh)
	# Et les transforme en coordonnees global
	#
	if (BL_VERSION<=223):
		m = Obj.matrix
	else:
		m = Obj.getMatrix()

	try:    ############################## Version officielle ############################################

		PX = P[0]*m[0][0] + P[1]*m[1][0] + P[2]*m[2][0] + m[3][0]
		PY = P[0]*m[0][1] + P[1]*m[1][1] + P[2]*m[2][1] + m[3][1]
		PZ = P[0]*m[0][2] + P[1]*m[1][2] + P[2]*m[2][2] + m[3][2]
		return [PX, PY, PZ]


	except: ############################## Version TUHOPUU ############################################

		PX = P[0]*m[0] + P[1]*m[4] + P[2]*m[8] + m[12]
		PY = P[0]*m[1] + P[1]*m[5] + P[2]*m[9] + m[13]
		PZ = P[0]*m[2] + P[1]*m[6] + P[2]*m[10] + m[14]
		return [PX, PY, PZ]

##########################
def LocalPosition(P, Obj):
##########################
	#
	# Prend les coordonnees global d'un point
	# Et les transforme en coordonnees locale  (Vertice from Mesh)
	#
	if (BL_VERSION<=223):
		m = Blender210.getObject(Obj.name).inverseMatrix
	else:
		m = Obj.getInverseMatrix()

	try:    ############################## Version officielle ############################################

		PX = P[0]*m[0][0] + P[1]*m[1][0] + P[2]*m[2][0] + m[3][0]
		PY = P[0]*m[0][1] + P[1]*m[1][1] + P[2]*m[2][1] + m[3][1]
		PZ = P[0]*m[0][2] + P[1]*m[1][2] + P[2]*m[2][2] + m[3][2]
		return [PX, PY, PZ]

	except: ############################## Version TUHOPUU ############################################

		PX = P[0]*m[0] + P[1]*m[4] + P[2]*m[8] + m[12]
		PY = P[0]*m[1] + P[1]*m[5] + P[2]*m[9] + m[13]
		PZ = P[0]*m[2] + P[1]*m[6] + P[2]*m[10] + m[14]
		return [PX, PY, PZ]

###############
def info_Obj(Ob=[]):
###############

	Obtype = 0
	mename = []
	me = []
	calque = 1

	if not Ob:
		if not Object.GetSelected():
			return Ob,Obtype,mename,me
		else:
			Ob = Object.GetSelected()[0]
			if (Ob.getType() == 'Mesh'):

				Obtype = 1
				calque = Ob.Layer                    # Le "layer" de l'object selectionne
				mename = Ob.getData().name
				me = Ob.getData()
	else:
		if (Ob.getType() == 'Mesh'):

			Obtype = 1
			calque = Ob.Layer                    # Le "layer" de l'object selectionne
			mename = Ob.getData().name
			me = Ob.getData()

	return Ob,Obtype,mename,me


#########################################
def D_Faces_f_VertAndD_Edges_f_Face(me):#
#########################################
# Dicos sous forme de NMesh.verts #
###################################

	D_ffv = {} ### DicoFacesfromVert={[NMVert]: [[NMFace],[NMFace],[NMFace]],  [NMVert]: [[NMFace],[NMFace]],  [NMVert]:  ...}
	D_eff = {} ### DicoEdgesfromFace={[NMFace]: [[NMVert,NMVert], [NMVert,NMVert],[NMVert,NMVert],[NMVert,NMVert]],  [NMFace]: [[NMVert,NMVert], [NMVert, ...}


	for x in me.verts:
		D_ffv[x] = []

	MeshFaces = me.faces

	for f in MeshFaces:
		lenF = len(f)

		D_eff[f] = []

		if lenF == 2:
			D_eff[f] = [f.v]

		else:

			for vidx in range(lenF):

				###### Section L_Ffv ##########
				if f not in D_ffv[f.v[vidx]]:
					D_ffv[f.v[vidx]].append(f)

				###### Section D_eff #########
				if vidx < (lenF-1):
					D_eff[f].append([f.v[vidx], f.v[vidx+1]])
				else:
					D_eff[f].append([f.v[vidx], f.v[0]])


	return D_ffv, D_eff

############################################################################
def ReturnFacesfromEdge(edge=[None,None], d_ffv={}, d_eff={}, selfFace=[]):#
############################################################################
# Retourne la liste des faces qui appartiennent a un edge donne #
#################################################################

#	print "1er vertice de l'edge  = ", edge[0]
#	print "2eme vertice de l'edge  = ", edge[1]

	if len(edge) > 2:
		error = "Error, an edge can be made by two and only two points !"
		raise error

	else:
#		print "d_ffv[edge[0]] = ", d_ffv[edge[0]]

		l_fcs = []
		[l_fcs.append(x) for x in d_ffv[edge[0]]]
		[l_fcs.append(x) for x in d_ffv[edge[1]]]
		reduce(l_fcs)

#		print "==== l_fcs =", l_fcs

		if selfFace:
			tp1 = []
			[tp1.append(x) for x in l_fcs]
			tp1.remove(selfFace)
			l_fcs = tp1

		l_ffe = []
		[l_ffe.append(f) for f in l_fcs if edge in d_eff[f] or (Swap2d(edge) in d_eff[f])]


	return l_ffe

##################################################
def ReturnVertsLink2Vert(Vtc, d_ffv={}, d_eff={}):
##########################################################
# Retourne la liste des vertex relies a un vertice donne #
##########################################################


	l_vl2v = []

	for f in d_ffv[Vtc]:
		for edg in d_eff[f]:
			if Vtc in edg:
				if Vtc == edg[0]:
					l_vl2v.append(edg[1])
				else:
					l_vl2v.append(edg[0])

	reduce(l_vl2v)

	return l_vl2v


######
def Swap2d(list=[None,None]):
######

	return [list[1], list[0]]


#######################
#### Fonction reduce ##
def reduce(list):     #
#######################

	list.sort()
	list.reverse()

	lenlist = len(list) - 1
	if lenlist > 0:
		compt = 0

		while compt < lenlist:

			if list[compt] == list[compt + 1]:
				list.remove(list[compt])
				lenlist -= 1

			else:
				compt += 1

	list.reverse()

	return list

################################
def listRemove(Orig_L, ToRem_L):
################################

	for x in ToRem_L:
		try:
			Orig_L.remove(x)
		except:
			pass

	return Orig_L

#########################
def SearcheDoubles(list):
#########################

	list.sort()
	Doublon = []
	for x in list:
		if list.count(x) == 2:
			Doublon.append(x)

	reduce(Doublon)

	return Doublon

#########################
def KeepOnlyUnique(list):
#########################

    liste2 = []
    for x in list:
        liste2.append(x)
    liste2.sort()
    list.reverse()
    for x in liste2:
        itemDouble = list.count(x)

        if itemDouble > 1:

            while itemDouble > 0:
                list.remove(x)
                itemDouble -= 1
    list.reverse()

    return list

######################################
def VertNoByListFaces(P=[], ListF=[], dffv={}):
######################################

	l_keepF = []
	F_no_X = 0.00
	F_no_Y = 0.00
	F_no_Z = 0.00

	for f in dffv[P]:
		if f in ListF:
			l_keepF.append(f)


	len_no = len(l_keepF)

	for f in l_keepF:
		F_no_X += f.normal[0]
		F_no_Y += f.normal[1]
		F_no_Z += f.normal[2]

	F_no_X /= len_no
	F_no_Y /= len_no
	F_no_Z /= len_no

	return (round(F_no_X,3), round(F_no_Y,3), round(F_no_Z,3))


########################
def TriageGrpFcs(ListF):
########################

	LF = Copy(ListF)
	GrNo = {}
	tpL = []
	compt = 1

	while len(LF):

		if len(LF):
			workF = LF.pop(0)

			ffv = []
			[ffv.extend(D_FacesfromVert[v]) for v in workF.v]

			for retFcs in ffv:

				if retFcs:
					if retFcs in LF:

						tpL.append(LF.pop(LF.index(retFcs)))

			tpL.insert(0, workF)

			if len(tpL) == 1:

				#### Face isole ####
				GrNo[compt] = [workF]
				tpL = []
				compt +=1

			else:

				#### On continue dans le groupe ####
				GrFpos = 1
				GrNo[compt] = tpL
				tpL = []

				while GrFpos < len(GrNo[compt]):

					workF = GrNo[compt][GrFpos]

					ffv = []
					[ffv.extend(D_FacesfromVert[v]) for v in workF.v]

					for retFcs in ffv:

						if retFcs:
							if retFcs in LF:

								tpL.append(LF.pop(LF.index(retFcs)))

					tptpL = GrNo[compt]
					tptpL.extend(tpL)
					GrNo[compt] = tptpL
					tpL = []

					GrFpos += 1

				compt += 1

#	print "Nous avons %s groupes." %(compt - 1)
#	print GrNo
#	print LF

	return GrNo

##############################
def getSelFacesFromSelVerts(me):
##############################
	global D_FacesfromVert, D_EdgesfromFace

	#####################################
	#####################################
#	print "Building ... DicoFacesfromVert"
	D_FacesfromVert, D_EdgesfromFace = D_Faces_f_VertAndD_Edges_f_Face(me)
#	print "DicoFacesfromVert...OK"
	#####################################

	L_SelV = [] #### Liste des vertex selectionnes ####
	for v in me.verts:
		if v.sel:
			L_SelV.append(v)
		v.sel = 0

	LF = []

	[LF.extend(D_FacesfromVert[vtc]) for vtc in L_SelV]
	reduce(LF)


	NewL_SelV = [] #### La nouvelle liste de vertex sur lequel nous allons travailler ####
	NewLF = [] #### La nouvelle liste de faces #####
	for f in LF:
		chk = []
		[chk.append(v) for v in f.v if v in L_SelV]
		if len(chk) == len(f.v):
			NewL_SelV.extend(f.v)
			NewLF.append(f)

	for v in NewL_SelV:
		v.sel = 1
	for f in me.faces:
		f.flag = 0
		if f in NewLF:
			f.flag = 1

	return NewLF


############
def CreaByFaces(chck):
############
	global Obj, mesh, meshname, D_FacesfromVert, listSelFacesOrig, DicoOldFaceVerts
	global AttributSelFaces, Undo, slOffset, level, tolerance, D_OrigCoNo, checkCol, GrFV


	listSelFacesOrig = mesh.getSelectedFaces() ## Init.
	DicoOldFaceVerts = {} ## Init.
	AttributSelFaces = {} #### les attributs de faces (ici: le smooth)

	if chck:
		#####################################
		#####################################
		print "Building ... DicoFacesfromVert"
		D_FacesfromVert, D_EdgesfromFace = D_Faces_f_VertAndD_Edges_f_Face(mesh)
		print "DicoFacesfromVert...OK"
		#####################################

	newfvIDX = []

	for f in listSelFacesOrig:  ########## Boucle faces selectionnes #############

			DicoOldFaceVerts[f] = [f.v]
			AttributSelFaces[f] = [f.smooth] ### Le smooth de la face
			if f.col:
				checkCol = 1


			idx = len(mesh.verts)
			newfv = []

			co_Facex = 0.00
			co_Facey = 0.00
			co_Facez = 0.00
			lenf = len(f.v)

			for v in f.v: ### Calcul du centre de la face ###
				co_Facex += v.co[0]
				co_Facey += v.co[1]
				co_Facez += v.co[2]
			co_Facex /= lenf
			co_Facey /= lenf
			co_Facez /= lenf


			for v in f.v:

				vx = v.co[0] + tolerance * f.no[0]
				vy = v.co[1] + tolerance * f.no[1]
				vz = v.co[2] + tolerance * f.no[2]

				newVert = NMesh.Vert(vx, vy, vz)

				mesh.verts.append(newVert)
				newfv.append(mesh.verts[-1]) #### Nouveaux vertex qui remplaceront l'ancienne bordure #####
				newfvIDX.append(idx)

				D_OrigCoNo[idx] = [(vx, vy, vz)] ### coordonnees du nouveau point
				D_OrigCoNo[idx].append(f.normal) ### normal du nouveau point
				D_OrigCoNo[idx].append([co_Facex, co_Facey, co_Facez]) ### Pivot de la face


				idx +=1


			DicoOldFaceVerts[f].append(newfv)

			f.v = newfv
#			print "DicoOldFaceVerts[f] =", DicoOldFaceVerts[f]




	OutFacesIDX = []

	for f in listSelFacesOrig:

		lenf = len(f.v)

		for nbNfcs in range(lenf):

			NewFace = NMesh.Face()

#			print "DicoOldFaceVerts[f][0] = ", DicoOldFaceVerts[f][nbNfcs]
			if nbNfcs < (lenf-1):

				NewFace.v.append(DicoOldFaceVerts[f][0][nbNfcs])
				NewFace.v.append(DicoOldFaceVerts[f][0][nbNfcs+1])
				NewFace.v.append(DicoOldFaceVerts[f][1][nbNfcs+1])
				NewFace.v.append(DicoOldFaceVerts[f][1][nbNfcs])

				if checkCol:
					Fcol = []
					Fcol.append(f.col[nbNfcs])
					Fcol.append(f.col[nbNfcs+1])
					Fcol.append(f.col[nbNfcs+1])
					Fcol.append(f.col[nbNfcs])
					Fuv = []
					Fuv.append(f.uv[nbNfcs])
					Fuv.append(f.uv[nbNfcs+1])
					Fuv.append(f.uv[nbNfcs+1])
					Fuv.append(f.uv[nbNfcs])

			else:

				NewFace.v.append(DicoOldFaceVerts[f][0][nbNfcs])
				NewFace.v.append(DicoOldFaceVerts[f][0][0])
				NewFace.v.append(DicoOldFaceVerts[f][1][0])
				NewFace.v.append(DicoOldFaceVerts[f][1][nbNfcs])

				if checkCol:
					Fcol = []
					Fcol.append(f.col[nbNfcs])
					Fcol.append(f.col[0])
					Fcol.append(f.col[0])
					Fcol.append(f.col[nbNfcs])
					Fuv = []
					Fuv.append(f.uv[nbNfcs])
					Fuv.append(f.uv[0])
					Fuv.append(f.uv[0])
					Fuv.append(f.uv[nbNfcs])

			mesh.faces.append(NewFace)

			lenFmesh = len(mesh.faces)
			AttributSelFaces[lenFmesh - 1] = []
			AttributSelFaces[lenFmesh - 1].append(AttributSelFaces[f][0])

			if checkCol:
				AttributSelFaces[lenFmesh - 1].append(Fcol) ### Vertex color de la face

				AttributSelFaces[lenFmesh - 1].append(Fuv) ### UVs de la face
				tpimg = GetOpenGLFaceImage(f)
				AttributSelFaces[lenFmesh - 1].append(tpimg) ### Image_UV de la face
				tpmodeF = f.mode
				AttributSelFaces[lenFmesh - 1].append(tpmodeF) ### mode de la face
				tptranspF = f.transp
				AttributSelFaces[lenFmesh - 1].append(tptranspF) ### transparence_mode de la face

			if mesh.materials:
				AttributSelFaces[lenFmesh - 1].append(f.materialIndex) ### copy du materialIndex de la face

			OutFacesIDX.append(lenFmesh - 1)


	NMesh.PutRaw(mesh, meshname)
	mesh.update(0)
	Obj.makeDisplayList()

	mesh = Obj.getData()


#### Deselection des faces sur la bordure ####
	for f in OutFacesIDX:
		mesh.faces[f].flag = 0
		mesh.faces[f].smooth = AttributSelFaces[f][0]
		if checkCol:
			mesh.faces[f].col = AttributSelFaces[f][1]

			mesh.faces[f].uv = AttributSelFaces[f][2]
			if AttributSelFaces[f][3]:
				mesh.faces[f].image = AttributSelFaces[f][3]
				mesh.faces[f].mode = AttributSelFaces[f][4]
				mesh.faces[f].transp = AttributSelFaces[f][5]

		if mesh.materials:
			mesh.faces[f].materialIndex = AttributSelFaces[f][6]

	checkCol = 0

	NMesh.PutRaw(mesh, meshname)
	mesh.update()
	Obj.makeDisplayList()

	if BL_VERSION > 231:
	#### Selection des newvertices ######
		for x in range(len(mesh.verts)):
			mesh.verts[x].sel = 0
			if x in newfvIDX:
				mesh.verts[x].sel = 1
	
	mesh.update(1)
	Obj.makeDisplayList()
###################################

	print "Creation ... OK."

#### Test ##########
#	print pivotAll_X, pivotAll_Y, pivotAll_Z
#	Window.SetCursorPos(pivotAll_X, pivotAll_Y, pivotAll_Z)  
####################

	slOffset.val = 0.00
	slScale.val = 100.00
	Draw()

	Undo[level][0] = mesh
	Undo[level][1] = D_OrigCoNo
	Undo[level][2] = slOffset.val
	Undo[level][3] = slOffsetMax.val
	Undo[level][4] = slScale.val
	GrFV = []
	Undo[level][5] = GrFV


	return 0


############
def CreationbyGr(chck):
############
	########## On va faire la liste des Edges Exterieur ######################################

	global Obj, mesh, meshname, D_FacesfromVert, listSelFacesOrig, listeSelectVerts, DicoEdgesOut, listNewSelFaces
	global AttributSelFaces, Undo, slOffset, level, tolerance, D_OrigCoNo, checkCol, ChckHl, GrFV


	listSelFacesOrig = mesh.getSelectedFaces() ## Init.
	AttributSelFaces = {} #### les attributs de faces (ici: le smooth)
	listeSelectVerts = [] #### la liste des vertex (NVerts) appartenant a la selection de faces ####
	DicoEdgesOut = {} ## Init.
	WorkingVerts = [] ## Init.

	if chck:
		#####################################
		#####################################
		print "Building ... DicoFacesfromVert"
		D_FacesfromVert, D_EdgesfromFace = D_Faces_f_VertAndD_Edges_f_Face(mesh)
		print "DicoFacesfromVert...OK"
		#####################################


	for f in listSelFacesOrig:  ########## Boucle faces selectionnes #############

			listeSelectVerts.extend(f.v)


			AttributSelFaces[f] = [f.smooth]
			if f.col:
				checkCol = 1


			for edg in D_EdgesfromFace[f]:

				RetFfE = ReturnFacesfromEdge(edg, D_FacesfromVert, D_EdgesfromFace, f)

				if  not RetFfE or (RetFfE[0] not in listSelFacesOrig):

					WorkingVerts.extend(edg)
					if not DicoEdgesOut.has_key(f):
						DicoEdgesOut[f] = [] ## Sous la forme: DicoEdgesOut= {[NMFace]:[[Edges], [Edge]], [NMFace]:[...}
					if edg not in DicoEdgesOut[f]:
						DicoEdgesOut[f].append(edg)

#	print "DicoFacesfromVert...OK", D_FacesfromVert

	listeSelectVerts.sort()

	reduce(listeSelectVerts)

	WorkingVerts.sort()

	reduce(WorkingVerts)

	StayingVerts = []  ############ Liste des vertex qui ne seront pas dupliquer ########
	[StayingVerts.append(x) for x in listeSelectVerts]

	listRemove(StayingVerts, WorkingVerts)

#######################################################################
################ Creation des nouveaux points #########################

#### Les points qui subiront l'OffScale ####

	NewWorkingVerts = {} #### 
	NewWorkingVertsIDX = [] #### Index des nouveaux points 
	idx = len(mesh.verts)

	for x in WorkingVerts:

		noX , noY , noZ = VertNoByListFaces(x, listSelFacesOrig, D_FacesfromVert)
#		print "noX , noY , noZ = %s, %s, %s " %(noX , noY , noZ)

		vx = x.co[0] + tolerance * noX
		vy = x.co[1] + tolerance * noY
		vz = x.co[2] + tolerance * noZ

		newVert = NMesh.Vert(vx, vy, vz)
		mesh.verts.append(newVert)
		NewWorkingVerts[x] = mesh.verts[-1] #### Nouveaux vertex qui remplaceront l'ancienne bordure #####
		NewWorkingVertsIDX.append(idx)
		D_OrigCoNo[idx] = [(vx, vy, vz)]
		D_OrigCoNo[idx].extend([(noX, noY, noZ)])

		idx +=1

	for x in StayingVerts:

		noX , noY , noZ = VertNoByListFaces(x, D_FacesfromVert[x], D_FacesfromVert)
#		print "noX , noY , noZ = %s, %s, %s " %(noX , noY , noZ)

		idx = mesh.verts.index(x)
		vx = x.co[0] + tolerance * noX
		vy = x.co[1] + tolerance * noY
		vz = x.co[2] + tolerance * noZ
		mesh.verts[idx].co[0] = vx
		mesh.verts[idx].co[1] = vy
		mesh.verts[idx].co[2] = vz
		NewWorkingVertsIDX.append(idx)
		D_OrigCoNo[idx] = [(vx, vy, vz)]
		D_OrigCoNo[idx].extend([(noX, noY, noZ)])

#		print "D_OrigCoNo[idx] =", D_OrigCoNo[idx]


#####################################################################
################ Reatribution des faces selectionnees ###############

	listNewSelFaces = {}

	for f in listSelFacesOrig:
		listNewSelFaces[f] = []
		for x in range(len(f.v)):
					try:
						listNewSelFaces[f].append(NewWorkingVerts[f.v[x]])

					except:
						listNewSelFaces[f].append(f.v[x])


		f.v = listNewSelFaces[f]

########### Les faces selectionnees, c'est OK ################
##############################################################

##############################################################
######### Creons maintenant les faces de cote #########

	OutFacesIDX = []

	for f in DicoEdgesOut.keys():
		for edge in DicoEdgesOut[f]:

			NewFace = NMesh.Face()

			NewFace.v.append(edge[0])
			NewFace.v.append(edge[1])
			NewFace.v.append(NewWorkingVerts[edge[1]])
			NewFace.v.append(NewWorkingVerts[edge[0]])

			if checkCol:
				Fcol = []
				Fcol.append(f.col[f.v.index(NewWorkingVerts[edge[0]])])
				Fcol.append(f.col[f.v.index(NewWorkingVerts[edge[1]])])
				Fcol.append(f.col[f.v.index(NewWorkingVerts[edge[1]])])
				Fcol.append(f.col[f.v.index(NewWorkingVerts[edge[0]])])
				Fuv = []
				Fuv.append(f.uv[f.v.index(NewWorkingVerts[edge[0]])])
				Fuv.append(f.uv[f.v.index(NewWorkingVerts[edge[1]])])
				Fuv.append(f.uv[f.v.index(NewWorkingVerts[edge[1]])])
				Fuv.append(f.uv[f.v.index(NewWorkingVerts[edge[0]])])

			mesh.faces.append(NewFace)

			lenFmesh = len(mesh.faces)
			AttributSelFaces[lenFmesh - 1] = []
			AttributSelFaces[lenFmesh - 1].append(AttributSelFaces[f][0])
			if checkCol:
				AttributSelFaces[lenFmesh - 1].append(Fcol) ### Vertex color de la face

				AttributSelFaces[lenFmesh - 1].append(Fuv) ### UVs de la face
				tpimg = GetOpenGLFaceImage(f)
				AttributSelFaces[lenFmesh - 1].append(tpimg) ### Image_UV de la face
				tpmodeF = f.mode
				AttributSelFaces[lenFmesh - 1].append(tpmodeF) ### mode de la face
				tptranspF = f.transp
				AttributSelFaces[lenFmesh - 1].append(tptranspF) ### transparence_mode de la face

			if mesh.materials:
				AttributSelFaces[lenFmesh - 1].append(f.materialIndex) ### copy du materialIndex de la face

			OutFacesIDX.append(lenFmesh - 1)

	NMesh.PutRaw(mesh, meshname)
	mesh.update(0)
	Obj.makeDisplayList()

	mesh = Obj.getData()



#### Deselection des faces sur la bordure ####
	for f in OutFacesIDX:
		mesh.faces[f].flag = 0
		mesh.faces[f].smooth = AttributSelFaces[f][0]

		if checkCol:
			mesh.faces[f].col = AttributSelFaces[f][1]
			mesh.faces[f].uv = AttributSelFaces[f][2]
			if AttributSelFaces[f][3]:
				mesh.faces[f].image = AttributSelFaces[f][3]
				mesh.faces[f].mode = AttributSelFaces[f][4]
				mesh.faces[f].transp = AttributSelFaces[f][5]

		if mesh.materials:
			mesh.faces[f].materialIndex = AttributSelFaces[f][6]

	checkCol = 0

	NMesh.PutRaw(mesh, meshname)
	mesh.update()
	Obj.makeDisplayList()

	if BL_VERSION > 231:
	#### Selection des newvertices ######
		for x in range(len(mesh.verts)):
			mesh.verts[x].sel = 0
			if x in NewWorkingVertsIDX:
				mesh.verts[x].sel = 1
	
	mesh.update(1)
	Obj.makeDisplayList()
###################################

#### Creation GrFVno #########################

	NewSFcs = mesh.getSelectedFaces()

	#####################################
	#####################################
#	print "Building ... DicoFacesfromVert"
	D_FacesfromVert, D_EdgesfromFace = D_Faces_f_VertAndD_Edges_f_Face(mesh)
#	print "DicoFacesfromVert...OK"
	#####################################

	GrFV = {}

	if ChckHl:
		GrFcs = NewSFcs
		tpV = []
		for f in GrFcs:
			tpV.extend(f.v)
		reduce(tpV)
		tpVidx = []
		for nmv in tpV:
			idx = mesh.verts.index(nmv)
			tpVidx.append(idx)

		GrFV[1] = tpVidx

		ChckHl = 0

	else:
		GrFcs = TriageGrpFcs(NewSFcs)

		for num in GrFcs.keys():
			tpV = []
			for f in GrFcs[num]:
				tpV.extend(f.v)
			reduce(tpV)
			tpVidx = []
			for nmv in tpV:
				idx = mesh.verts.index(nmv)
				tpVidx.append(idx)

			GrFV[num] = tpVidx

#	print "GrFV = ", GrFV

#########################################


	print "Creation ... OK."

#### Test ##########
#	print pivotAll_X, pivotAll_Y, pivotAll_Z
#	Window.SetCursorPos(pivotAll_X, pivotAll_Y, pivotAll_Z)  
####################

	slOffset.val = 0.00
	slScale.val = 100.00
	Draw()

	Undo[level][0] = mesh
	Undo[level][1] = D_OrigCoNo
	Undo[level][2] = slOffset.val
	Undo[level][3] = slOffsetMax.val
	Undo[level][4] = slScale.val
	Undo[level][5] = GrFV


	return 0

################
def CheckHole():
################
	global Obj, mesh, meshname, D_FacesfromVert, listSelFacesOrig, DicoEdgesOut
	global AttributSelFaces, checkCol


	listSelFacesOrig = mesh.getSelectedFaces() ## Init.
	AttributSelFaces = {} #### les attributs de faces (ici: le smooth)
	DicoF_fv = {} #### la liste des vertex (NVerts) appartenant a la selection de faces ####
	DicoEdgesOut = {} ## Init.
	WorkingVerts = [] ## Init.


	#####################################
	#####################################
	print "Building ... DicoFacesfromVert"
	D_FacesfromVert, D_EdgesfromFace = D_Faces_f_VertAndD_Edges_f_Face(mesh)
	print "DicoFacesfromVert...OK"
	#####################################


	for f in listSelFacesOrig:  ########## Boucle faces selectionnes #############

			DicoF_fv[f] = f.v


			AttributSelFaces[f] = [f.smooth]
			if f.col:
				checkCol = 1
#				DicoF_fv[f].append(f.col)


			for edg in D_EdgesfromFace[f]:

				RetFfE = ReturnFacesfromEdge(edg, D_FacesfromVert, D_EdgesfromFace, f)

				if  not RetFfE:

					WorkingVerts.extend(edg)
					if not DicoEdgesOut.has_key(f):
						DicoEdgesOut[f] = [] ## Sous la forme: DicoEdgesOut= {[NMFace]:[[Edges], [Edge]], [NMFace]:[...}
					if edg not in DicoEdgesOut[f]:
						DicoEdgesOut[f].append(edg)


	WorkingVerts.sort()
	reduce(WorkingVerts)

	if not WorkingVerts:
		return 0



#######################################################################
################ Creation des nouveaux points #########################

#### Les points qui subiront l'OffScale ####

	NewWorkingVerts = {} #### 
	NewWorkingVertsIDX = [] #### Index des nouveaux points 
	idx = len(mesh.verts)

	tplistverts = []
	[tplistverts.append(v) for v in mesh.verts]

	for x in tplistverts:

		if x not in WorkingVerts:

			vx = x.co[0]
			vy = x.co[1]
			vz = x.co[2]

			newVert = NMesh.Vert(vx, vy, vz)
			mesh.verts.append(newVert)
			NewWorkingVerts[x] = mesh.verts[-1] #### Nouveaux vertex qui remplaceront l'ancienne bordure #####
			NewWorkingVertsIDX.append(idx)

			idx +=1

		else:
			NewWorkingVerts[x] = x
			Vidx = mesh.verts.index(x)
			NewWorkingVertsIDX.append(Vidx)


#### Je flip les faces premieres #####
	for f in mesh.faces:
		f.v.reverse()
		if checkCol:
			f.col.reverse()
			f.uv.reverse()


################################################################################
######### Creons maintenant les faces qui seront la nouvelle selection #########

	OutFacesIDX = []

	for f in DicoF_fv.keys():

		if len(f.v) == 4:

			NewFace = NMesh.Face()

			NewFace.v.append(NewWorkingVerts[f.v[3]])
			NewFace.v.append(NewWorkingVerts[f.v[2]])
			NewFace.v.append(NewWorkingVerts[f.v[1]])
			NewFace.v.append(NewWorkingVerts[f.v[0]])

			if checkCol:
				Fcol = []
				Fcol.append(f.col[3])
				Fcol.append(f.col[2])
				Fcol.append(f.col[1])
				Fcol.append(f.col[0])

			mesh.faces.append(NewFace)

		elif len(f.v) == 3:

			NewFace = NMesh.Face()

			NewFace.v.append(NewWorkingVerts[f.v[2]])
			NewFace.v.append(NewWorkingVerts[f.v[1]])
			NewFace.v.append(NewWorkingVerts[f.v[0]])

			if checkCol:
				Fcol = []
				Fcol.append(f.col[2])
				Fcol.append(f.col[1])
				Fcol.append(f.col[0])

			mesh.faces.append(NewFace)

		lenFmesh = len(mesh.faces)
		AttributSelFaces[lenFmesh - 1] = []
		AttributSelFaces[lenFmesh - 1].append(AttributSelFaces[f][0])
		if checkCol:
			AttributSelFaces[lenFmesh - 1].append(Fcol) ### Vertex color de la face
			tpUV = Copy(f.uv)
			tpUV.reverse()
			AttributSelFaces[lenFmesh - 1].append(tpUV) ### UVs de la face
			tpimg = GetOpenGLFaceImage(f)
			AttributSelFaces[lenFmesh - 1].append(tpimg) ### Image_UV de la face
			tpmodeF = f.mode
			AttributSelFaces[lenFmesh - 1].append(tpmodeF) ### mode de la face
			tptranspF = f.transp
			AttributSelFaces[lenFmesh - 1].append(tptranspF) ### transparence_mode de la face

		if mesh.materials:
			AttributSelFaces[lenFmesh - 1].append(f.materialIndex) ### copy du materialIndex de la face

		OutFacesIDX.append(lenFmesh - 1)

	NMesh.PutRaw(mesh, meshname)
	mesh.update(0)
	Obj.makeDisplayList()

	mesh = Obj.getData()

#### Selection des nouvelles selectedfaces ####
	for f in range(len(mesh.faces)):
		mesh.faces[f].flag = 0

		if f >= (len(mesh.faces)/2):
			mesh.faces[f].flag = 1
			mesh.faces[f].smooth = AttributSelFaces[f][0]

			if checkCol:
				mesh.faces[f].col = AttributSelFaces[f][1]
				mesh.faces[f].uv = AttributSelFaces[f][2]
				if AttributSelFaces[f][3]:
					mesh.faces[f].image = AttributSelFaces[f][3]
					mesh.faces[f].mode = AttributSelFaces[f][4]
					mesh.faces[f].transp = AttributSelFaces[f][5]

			if mesh.materials:
				mesh.faces[f].materialIndex = AttributSelFaces[f][6]

	checkCol = 0

	NMesh.PutRaw(mesh, meshname)
	mesh.update(1)
	Obj.makeDisplayList()


	return 1

######################
def Copy(ToCopy = []):
######################

	A = []
	[A.append(x) for x in ToCopy]

	return A

##########################
def GetOpenGLFaceImage(f):
##########################

	img = []

	if f.image:

			img = f.image


	return img

######################
def OffScale(me = []):
######################
	global Obj, mesh, meshname, D_OrigCoNo, slScale, slOffset, slOffsetMax, tolerance, level, GrFV


	if mesh:
		if level:

			me = Obj.getData()

			Undo[level][0] = me
			Undo[level][1] = D_OrigCoNo
			Undo[level][2] = slOffset.val
			Undo[level][3] = slOffsetMax.val
			Undo[level][4] = slScale.val
			Undo[level][5] = GrFV


			if len(D_OrigCoNo[D_OrigCoNo.keys()[0]]) == 3: ### By Faces

				for id in Undo[level][1].keys():

					cox1 = (Undo[level][1][id][0][0] - Undo[level][1][id][2][0]) * ((Undo[level][4] - 100.00) /100.00)
					coy1 = (Undo[level][1][id][0][1] - Undo[level][1][id][2][1]) * ((Undo[level][4] - 100.00) /100.00)
					coz1 = (Undo[level][1][id][0][2] - Undo[level][1][id][2][2]) * ((Undo[level][4] - 100.00) /100.00)

					me.verts[id].co[0] = Undo[level][1][id][0][0] + cox1 + (Undo[level][2] * Undo[level][3] * Undo[level][1][id][1][0]/100.00)
					me.verts[id].co[1] = Undo[level][1][id][0][1] + coy1 + (Undo[level][2] * Undo[level][3] * Undo[level][1][id][1][1]/100.00)
					me.verts[id].co[2] = Undo[level][1][id][0][2] + coz1 + (Undo[level][2] * Undo[level][3] * Undo[level][1][id][1][2]/100.00)


			else: ### By Group

				for gr in GrFV.keys():

					###### Pivot somme all faces ######
					Loc_pivotAll_X = 0.00
					Loc_pivotAll_Y = 0.00
					Loc_pivotAll_Z = 0.00
					LenPivot_V = 0.00
					###################################

					for id in GrFV[gr]:

						cox1 = Undo[level][1][id][0][0] + (Undo[level][2] * Undo[level][3] * Undo[level][1][id][1][0]/100.00)
						coy1 = Undo[level][1][id][0][1] + (Undo[level][2] * Undo[level][3] * Undo[level][1][id][1][1]/100.00)
						coz1 = Undo[level][1][id][0][2] + (Undo[level][2] * Undo[level][3] * Undo[level][1][id][1][2]/100.00)

						Loc_pivotAll_X += cox1
						Loc_pivotAll_Y += coy1
						Loc_pivotAll_Z += coz1
						LenPivot_V += 1

					Loc_pivotAll_X /= LenPivot_V
					Loc_pivotAll_Y /= LenPivot_V
					Loc_pivotAll_Z /= LenPivot_V


					for id in GrFV[gr]:

						cox1 = Undo[level][1][id][0][0] + (Undo[level][2] * Undo[level][3] * Undo[level][1][id][1][0]/100.00)
						coy1 = Undo[level][1][id][0][1] + (Undo[level][2] * Undo[level][3] * Undo[level][1][id][1][1]/100.00)
						coz1 = Undo[level][1][id][0][2] + (Undo[level][2] * Undo[level][3] * Undo[level][1][id][1][2]/100.00)

						me.verts[id].co[0] = cox1 + ((cox1 -  Loc_pivotAll_X) * (Undo[level][4] - 100.00) /100.00)
						me.verts[id].co[1] = coy1 + ((coy1 -  Loc_pivotAll_Y) * (Undo[level][4] - 100.00) /100.00)
						me.verts[id].co[2] = coz1 + ((coz1 -  Loc_pivotAll_Z) * (Undo[level][4] - 100.00) /100.00)

	#				print "Loc_pivotAll_X = ", Loc_pivotAll_X
	#				print "Loc_pivotAll_Y = ", Loc_pivotAll_Y
	#				print "Loc_pivotAll_Z = ", Loc_pivotAll_Z

			NMesh.PutRaw(me, meshname)
			me.update(0)
			Obj.makeDisplayList()



	return 0


#############
def UNDO():
#############
	global Obj, mesh, meshname, checkExtrusion, D_OrigCoNo, level, slScale, slOffset, slOffsetMax, UndoFirst, GrFV


	if level >= 0:
		mesh = Undo[level][0]
		NMesh.PutRaw(mesh, meshname)
		mesh.update()
		Obj.makeDisplayList()
		D_OrigCoNo = Undo[level][1]
		slOffset.val = Undo[level][2]
		slOffsetMax.val = Undo[level][3]
		slScale.val = Undo[level][4]
		GrFV = Undo[level][5]
		Draw()


	elif level == -1:

		mesh = UndoFirst
		NMesh.PutRaw(mesh, meshname)
		mesh.update()
		Obj.makeDisplayList()
		D_OrigCoNo = Undo[level][1]
		slOffset.val = Undo[level][2]
		slOffsetMax.val = Undo[level][3]
		slScale.val = Undo[level][4]
		GrFV = Undo[level][5]
		Draw()


		checkExtrusion = 0


	return 0

###########
def REDO():
###########
		global Obj, mesh, meshname, level, D_OrigCoNo, slScale, slOffset, slOffsetMax, GrFV


		mesh = Undo[level][0]

		NMesh.PutRaw(mesh, meshname)
		mesh.update()
		Obj.makeDisplayList()

		D_OrigCoNo = Undo[level][1]
		slOffset.val = Undo[level][2]
		slOffsetMax.val = Undo[level][3]
		slScale.val = Undo[level][4]
		GrFV = Undo[level][5]
		Draw()


		return 0

#################
def Initialise():
#################
	global Obj, mesh, meshname, LastSelObj, level, UndoFirst, Undo, slOffset, slOffsetMax, slScale, checkExtrusion, levelMax, GrFV

	Obj,Objtype,meshname,mesh = info_Obj()

	if Objtype:

		LastSelObj = []
		level = 0
		levelMax = 0

		D_OrigCoNo = {}
		UndoFirst = Obj.getData()
		Undo = {}
		Undo[level] = [Obj.getData()]
		Undo[level].append(D_OrigCoNo) ## Stockage des donnees
		slOffset.val = 0.00
		slScale.val = 100.00
		Draw()
		Undo[level].append(slOffset.val) ## Stockage des donnees
		Undo[level].append(slOffsetMax.val) ## Stockage des donnees
		Undo[level].append(slScale.val) ## Stockage des donnees
		Undo[level].append(GrFV)

		checkExtrusion = 0

	return 0

##############
def delRedo():
##############
	global Undo, level, levelMax

	for x in range(level + 1, levelMax +1):
		del(Undo[x])

	levelMax = level

	return 0


###########
def main():
###########
	global Obj, mesh, meshname, Undo
	global LastSelObj, checkExtrusion
	global D_OrigCoNo, level, levelMax, UndoFirst, checkbyFce, ChckHl, GrFV, capshole

	SelectedFaces = []
	Obj,Objtype,meshname,mesh = info_Obj()

	if Objtype:
		if modemesh:
			SelectedFaces = getSelFacesFromSelVerts(mesh)
		if (mesh.getSelectedFaces() or SelectedFaces) and not mesh.getVertGroupNames():

			print
			print "Working..."

			mesh.update(1)
			Obj.makeDisplayList()

			if LastSelObj != meshname or (level == 0):
				LastSelObj = meshname
				level = 0

				D_OrigCoNo = {}
				UndoFirst = Obj.getData()
				Undo[level] = [Obj.getData()]
				Undo[level].append(D_OrigCoNo) ## Stockage des donnees
				Undo[level].append(slOffset.val) ## Stockage des donnees
				Undo[level].append(slOffsetMax.val) ## Stockage des donnees
				Undo[level].append(slScale.val) ## Stockage des donnees
				Undo[level].append(GrFV)


			checkExtrusion = 1

			if levelMax == level:
				levelMax += 1
			level += 1

			D_OrigCoNo = {}

			Undo[level] = [Obj.getData()]
			Undo[level].append(D_OrigCoNo) ## Stockage des donnees
			Undo[level].append(slOffset.val) ## Stockage des donnees
			Undo[level].append(slOffsetMax.val) ## Stockage des donnees
			Undo[level].append(slScale.val) ## Stockage des donnees
			Undo[level].append(GrFV)

			chkH = 1
			if checkbyFce:

				if (len(mesh.faces) == 1) == len(mesh.getSelectedFaces()) and capshole.val:
					chkH = CheckHole()

				CreaByFaces(chkH)

			else:

				if len(mesh.getSelectedFaces()) == len(mesh.faces) and capshole.val:
					chkH = CheckHole()

				CreationbyGr(chkH)

		if mesh.getVertGroupNames():
			print
			print "=================================================="
			print "WARNING: Don't work on object with 'WeightGroup' !"
			print "=================================================="

	return 0

###################



###########
def draw():
###########
	global EVENT_EXIT, EVENT_GRPFCE, EVENT_OFF, EVENT_SCALE, EVENT_OFFMAX, EVENT_EXTR, EVENT_UNDO, EVENT_REDO, EVENT_FREE
	global EVENT_WPOS_U, EVENT_WPOS_D, EVENT_WPOS_L, EVENT_WPOS_R
	global togGrpFce, togGrpFceTxt, slOffset, slScale, slOffsetMax, slScaleMax, W_up, W_down, W_left, W_right, capshole, interact

	color1 = (0.99, 0.99, 0.65)
	color2 = (0.567, 0.476, 0.365)
	color2Clear = (0.567, 0.476, 0.365, 1)
	color3 = (1.0, 1.0, 0.79)
	color4 = (0.265, 0.41, 0.4)
	color4Clear = (0.265, 0.41, 0.4, 1)
	color5 = (0.4, 0.472, 0.472)
	color6 = (0.5, 0.25, 0.25)
	color7 = (0.265, 0.4, 0.3)
	colorblack = (0.0, 0.0, 0.0)
	colorwhite = (1.0, 1.0, 1.0)
	colorred = (1.0, 0.0, 0.0)
	colorcyan = (0.0, 1.0, 1.0)
	colorgrey1 = (0.8, 0.8, 0.8)

	WindowSize = Buffer(GL_FLOAT, 4)
	glGetFloatv(GL_SCISSOR_BOX, WindowSize)
	WindowSize = WindowSize.list
#	print WindowSize

	apply(glClearColor, color4Clear)

	glClear(GL_COLOR_BUFFER_BIT)

	apply(glColor3f, colorblack)
	glRecti((int(WindowSize[2] - 265) * W_right.val) + 1, (int(WindowSize[3] - 288) * W_up.val) - 1, (int(WindowSize[2] - 265) * W_right.val) + 265, (int(WindowSize[3] - 288) * W_up.val) + 285)
	apply(glColor3f, colorgrey1)
	glRecti((int(WindowSize[2] - 265) * W_right.val) + 0, (int(WindowSize[3] - 288) * W_up.val) + 1, (int(WindowSize[2] - 265) * W_right.val) + 264, (int(WindowSize[3] - 286) * W_up.val) + 286)
	apply(glColor3f, color7)
	glRecti((int(WindowSize[2] - 265) * W_right.val) + 1, (int(WindowSize[3] - 288) * W_up.val) + 1, (int(WindowSize[2] - 265) * W_right.val) + 264, (int(WindowSize[3] - 288) * W_up.val) + 285)

	apply(glColor3f, colorblack)
	glRecti((int(WindowSize[2] - 265) * W_right.val) + 1, (int(WindowSize[3] - 288) * W_up.val) + 249, (int(WindowSize[2] - 265) * W_right.val) + 264, (int(WindowSize[3] - 288) * W_up.val) + 285)
	glColor3f(0.265, 0.35, 0.3)
	glRecti((int(WindowSize[2] - 265) * W_right.val) + 1, (int(WindowSize[3] - 288) * W_up.val) + 250, (int(WindowSize[2] - 265) * W_right.val) + 264, (int(WindowSize[3] - 288) * W_up.val) + 285)

	apply(glColor3f, colorblack)
	glRecti((int(WindowSize[2] - 265) * W_right.val) + 1, (int(WindowSize[3] - 288) * W_up.val) + 280, (int(WindowSize[2] - 265) * W_right.val) + 130, (int(WindowSize[3] - 288) * W_up.val) + 252)
	apply(glColor3f, colorgrey1)
	glRecti((int(WindowSize[2] - 265) * W_right.val) + 1, (int(WindowSize[3] - 288) * W_up.val) + 281, (int(WindowSize[2] - 265) * W_right.val) + 129, (int(WindowSize[3] - 288) * W_up.val) + 254)
	apply(glColor3f, color6)
	glRecti((int(WindowSize[2] - 265) * W_right.val) + 1, (int(WindowSize[3] - 288) * W_up.val) + 280, (int(WindowSize[2] - 265) * W_right.val) + 129, (int(WindowSize[3] - 288) * W_up.val) + 253)

	apply(glColor3f, colorblack)
	glRasterPos2f((int(WindowSize[2] - 265) * W_right.val) + 22, (int(WindowSize[3] - 288) * W_up.val) + 262)
	Text("ph_Extruder.py")
	glRasterPos2f((int(WindowSize[2] - 265) * W_right.val) + 21, (int(WindowSize[3] - 288) * W_up.val) + 263)
	Text("ph_Extruder.py")
	apply(glColor3f, colorwhite)
	glRasterPos2f((int(WindowSize[2] - 265) * W_right.val) + 20, (int(WindowSize[3] - 288) * W_up.val) + 264)
	Text("ph_Extruder.py")

	W_up = Toggle("", EVENT_WPOS_U, (int(WindowSize[2] - 265) * W_right.val) + 180, (int(WindowSize[3] - 288) * W_up.val) +273, 7, 7, W_up.val, "Move to the up of the window")
	W_down = Toggle("", EVENT_WPOS_D, (int(WindowSize[2] - 265) * W_right.val) + 180, (int(WindowSize[3] - 288) * W_up.val) +257, 7, 7, W_down.val, "Move to the down of the window")
	W_left = Toggle("", EVENT_WPOS_L, (int(WindowSize[2] - 265) * W_right.val) + 171, (int(WindowSize[3] - 288) * W_up.val) +265, 7, 7, W_left.val, "Move to the left of the window")
	W_right = Toggle("", EVENT_WPOS_R, (int(WindowSize[2] - 265) * W_right.val) + 189, (int(WindowSize[3] - 288) * W_up.val) +265, 7, 7, W_right.val, "Move to the right of the window")


	Button("Exit", EVENT_EXIT, (int(WindowSize[2] - 265) * W_right.val) + 205, (int(WindowSize[3] - 288) * W_up.val) + 258, 50, 20, "Quit")


	togGrpFce = Toggle(togGrpFceTxt, EVENT_GRPFCE, (int(WindowSize[2] - 265) * W_right.val) + 70, (int(WindowSize[3] - 288) * W_up.val) + 205, 80, 25, togGrpFce.val, "Extrude by group or by face.")
	capshole = Toggle("Capshole", EVENT_OFFMAX, (int(WindowSize[2] - 265) * W_right.val) + 185, (int(WindowSize[3] - 288) * W_up.val) + 207, 60, 20, capshole.val, "Close mesh on open mesh if all faces are selected.")

	Button("Extrude", EVENT_EXTR, (int(WindowSize[2] - 265) * W_right.val) + 62, (int(WindowSize[3] - 288) * W_up.val) + 65, 100, 28, "Extrude selected faces.")
	Button("Undo", EVENT_UNDO, (int(WindowSize[2] - 265) * W_right.val) + 60, (int(WindowSize[3] - 288) * W_up.val) + 20, 50, 22)
	Button("Redo", EVENT_REDO, (int(WindowSize[2] - 265) * W_right.val) + 114, (int(WindowSize[3] - 288) * W_up.val) + 20, 50, 22)

	Button("Free buffer", EVENT_FREE, (int(WindowSize[2] - 265) * W_right.val) + 180, (int(WindowSize[3] - 288) * W_up.val) + 20, 70, 22, "Apply transformation and free buffer.")

	apply(glColor3f, colorwhite)
	glRasterPos2f((int(WindowSize[2] - 265) * W_right.val) + 20, (int(WindowSize[3] - 288) * W_up.val) + 130)
	Text("Scale :")

	interact = Toggle("inter.", EVENT_OFFMAX, (int(WindowSize[2] - 265) * W_right.val) + 205, (int(WindowSize[3] - 288) * W_up.val) + 160, 40, 20, interact.val, "Real-time interactivity on/off (keep off with complex mesh).")

	slScale = Slider('', EVENT_SCALE, (int(WindowSize[2] - 265) * W_right.val) + 70, (int(WindowSize[3] - 288) * W_up.val) + 125, 80, 20, slScale.val, -slScaleMax.val, slScaleMax.val, interact.val, "Scale in pourcentage.")
	slScaleMax = Number('', EVENT_OFFMAX, (int(WindowSize[2] - 265) * W_right.val) + 154, (int(WindowSize[3] - 288) * W_up.val) + 125, 60, 20, slScaleMax.val, 200, 10000, "Maximum pourcentage of scale.")

	glRasterPos2f((int(WindowSize[2] - 265) * W_right.val) + 20, (int(WindowSize[3] - 286) * W_up.val) + 165)
	Text("Offset :")
	slOffset = Slider('', EVENT_OFF, (int(WindowSize[2] - 265) * W_right.val) + 70, (int(WindowSize[3] - 288) * W_up.val) + 160, 80, 20, slOffset.val, -100.00, 100.00, interact.val, "Pourcentage of 'OffsetMax'.")
	slOffsetMax = Number('', EVENT_OFFMAX, (int(WindowSize[2] - 265) * W_right.val) + 154, (int(WindowSize[3] - 288) * W_up.val) + 160, 40, 20, slOffsetMax.val, 1, 100, "OffsetMax in generic unity.")


####################
def event(evt, val):
####################
	if ( evt == ESCKEY and not val):
		Exit()

	if (evt== QKEY and not val):
		Exit()



################
def bevent(evt):
################
	global EVENT_EXIT, EVENT_GRPFCE, EVENT_OFF, EVENT_SCALE, EVENT_OFFMAX, EVENT_EXTR, EVENT_UNDO, EVENT_REDO, EVENT_FREE
	global EVENT_WPOS_U, EVENT_WPOS_D, EVENT_WPOS_L, EVENT_WPOS_R, W_up, W_down, W_left, W_right
	global checkExtrusion, mesh, Undo, checkOffScale, level, levelMax, slScale, slOffset, togGrpFceTxt, togGrpFce, checkbyFce

	if (evt == EVENT_EXIT):
		Exit()

	if (evt == EVENT_GRPFCE):
		if togGrpFce.val:
			togGrpFceTxt = "By faces."
			checkbyFce = 1
		else:
			togGrpFceTxt = "By group."
			checkbyFce = 0
		Blender.Redraw()


	if (evt == EVENT_OFFMAX):
		Blender.Redraw()

	if (evt == EVENT_WPOS_U):
		if W_up.val:
			W_down.val = 0
		else:
			W_down.val = 1
		Blender.Redraw()

	if (evt == EVENT_WPOS_D):
		if W_down.val:
			W_up.val = 0
		else:
			W_up.val = 1
		Blender.Redraw()

	if (evt == EVENT_WPOS_L):
		if W_left.val:
			W_right.val = 0
		else:
			W_right.val = 1
		Blender.Redraw()

	if (evt == EVENT_WPOS_R):
		if W_right.val:
			W_left.val = 0
		else:
			W_left.val = 1
		Blender.Redraw()
		

	if (evt == EVENT_EXTR) or (evt == EVENT_OFF) or (evt == EVENT_SCALE):

		if (evt == EVENT_EXTR):
			if level < levelMax:
				delRedo()
			editbegin()
			main()
			editend()

		if (evt == EVENT_OFF):
			if level < levelMax:
				delRedo()

			if level == 0 or not checkExtrusion:
				slOffset.val = 0.00
			elif checkExtrusion and level >= 0:
				checkOffScale = 0
				editbegin()
				OffScale()
				editend()

			Blender.Redraw()

		if (evt == EVENT_SCALE):
			if level < levelMax:
				delRedo()

			if level == 0 or not checkExtrusion:
				slScale.val = 100.00
			elif checkExtrusion and level >= 0:
				checkOffScale = 1
				editbegin()
				OffScale()
				editend()

			Blender.Redraw()

	if ((evt == EVENT_UNDO) and checkExtrusion and level > 0):

		level -= 1
		editbegin()
		UNDO()
		editend()
		print
		print "Undoing... OK"

	if ((evt == EVENT_REDO) and Undo.has_key((level+1))):

		level += 1
		editbegin()
		REDO()
		editend()
		Blender.Redraw()
		print
		print "Redoing... OK"

	if (evt == EVENT_FREE):
		editbegin()
		Initialise()
		editend()
		print
		print "Free buffer... OK"

######################
Register(draw, event, bevent)
######################